package com.fp.general.rules.query.code;

import java.util.List;

import com.fp.base.persistence.util.helper.GeneralDescriptions;
import com.fp.bpm.query.Query;
import com.fp.dto.Response;
import com.fp.dto.query.QueryRequest;
import com.fp.dto.rules.QueryRule;
import com.fp.persistence.pgeneral.installment.TgeneInstallmentType;

/**
 * Clase que se encarga de completar la descripcion del modulo, dado su codigo.
 * 
 * @author Wilson Sigcho
 * @version 2.1
 */
public class ModuleDesc extends QueryRule {

    /**
     * Metodo que agrega la descripcion de un modulo, dado su codigo en una consulta requerida.
     * 
     * @param pQueryRequest Objeto que posee la consulta requerida.
     * @return pQueryRequest
     * @throws Exception
     */
    @Override
    public QueryRequest process(QueryRequest pQueryRequest) throws Exception {
        Response response = pQueryRequest.getResponse();
        Query qry = new Query();
        qry.process(pQueryRequest);
        List<Object> lobjects = (List<Object>) response.get("TGENEINSTALLMENTTYPE");
        if (lobjects == null) {
            return pQueryRequest;
        }
        for (Object obj : lobjects) {
            TgeneInstallmentType tgeneInstallmentType = (TgeneInstallmentType) obj;
            if (tgeneInstallmentType.getPk().getModulecode() != null) {
                tgeneInstallmentType.addAddtionalInfo("moduledesc", GeneralDescriptions.getModuledesc(tgeneInstallmentType.getPk().getModulecode()));
            } else {
                tgeneInstallmentType.addAddtionalInfo("moduledesc", null);
            }
        }
        return pQueryRequest;
    }
}
